#firfilter.py
import numpy as np, scipy.signal as signal 
from matplotlib import pyplot as plt

sampleRate = 2000					#采样频率,每秒2000个样本
x = np.fromfile("ecgsignal.dat",dtype=np.float32)
x -= np.mean(x)                     #去直流分量
b = signal.firwin(1001,[3.0,30.0],fs=sampleRate,pass_zero=False)  #生成3 ~ 30Hz的带通滤波器
x = signal.lfilter(b,1,x)           #进行带通滤波

sampleCount = x.shape[0]			#采样数
t = np.linspace(0,sampleCount/sampleRate,sampleCount)
xFFT = np.abs(np.fft.rfft(x)/sampleCount)  #快速傅里叶变换计算频谱
xFreqs = np.linspace(0, sampleRate/2, sampleCount//2+1)

plt.figure(figsize=(10,6))
ax0 = plt.subplot(211)             #画时域信号
ax0.set_xlabel("Time(s)")
ax0.set_ylabel("Amp(μV)")
ax0.axis([np.min(t),np.max(t),-2000,2000])
ax0.plot(t,x,color='g')

ax1 = plt.subplot(212)             #画频域信号-频谱
ax1.set_xlabel("Freq(Hz)")
ax1.set_ylabel("Power")
ax1.plot(xFreqs,xFFT)

plt.subplots_adjust(0.1,0.1,0.95,0.95,hspace=0.3)
plt.show()


