#firphase.py
import numpy as np, scipy.signal as signal 
from matplotlib import pyplot as plt

sampleRate = 2000					 #采样频率,每秒2000个样本
x = np.fromfile("ecgsignal.dat",dtype=np.float32)
x -= np.mean(x)                      #去直流分量

b = signal.firwin(1001,[3.0,30.0],fs=sampleRate,pass_zero=False)  #生成3 ~ 30Hz的带通滤波器
y1 = signal.lfilter(b,1,x)           #滤波，有相位延迟
y2 = signal.filtfilt(b,1,x)          #滤波，无相位延迟   

sampleCount = x.shape[0]			 #采样数
t = np.linspace(0,sampleCount/sampleRate,sampleCount)

plt.figure(figsize=(10,6))
ax0 = plt.subplot(311)               #画原始时域信号
ax0.set_xlabel("Time(s) - Original Signal")
ax1 = plt.subplot(312)               #画相位延迟滤波后的时域信号
ax1.set_xlabel("Time(s) - With Phase Shift")
ax2 = plt.subplot(313)               #画无相位延迟滤波后的时域信号
ax2.set_xlabel("Time(s) - Without Phase Shift")
for ax, y in zip([ax0,ax1,ax2],[x,y1,y2]):
    ax.set_ylabel("Amp(μV)")
    ax.axis([np.min(t),np.max(t),-2000,2000])
    ax.plot(t,y)

plt.subplots_adjust(0.1,0.1,0.95,0.95,hspace=0.5)
plt.show()
