#spectrum.py
import numpy as np, matplotlib.pyplot as plt

sampleRate = 2000					#采样频率,每秒2000个样本
x = np.fromfile("ecgsignal.dat",dtype=np.float32) 
x -= np.mean(x)                     #去直流分量
sampleCount = x.shape[0]			#采样数
t = np.linspace(0,sampleCount/sampleRate,sampleCount)  
xFFT = np.abs(np.fft.rfft(x)/sampleCount)  #快速傅里叶变换
xFreqs = np.linspace(0, sampleRate/2, sampleCount//2+1)

plt.figure(figsize=(10,6))
ax0 = plt.subplot(2,1,1)             #上方子图画时域信号
ax0.set_xlabel("Time(s)")
ax0.set_ylabel("Amp(μV)")
ax0.plot(t,x)

ax1 = plt.subplot(2,1,2)             #下方子图画频谱
ax1.set_xlabel("Freq(Hz)")
ax1.set_ylabel("Power")
ax1.plot(xFreqs, xFFT)
plt.subplots_adjust(0.1,0.1,0.95,0.95,hspace=0.2)
plt.show()
